package com.ruoyi.zhdd.service.impl;

import cn.hutool.core.bean.BeanUtil;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.common.utils.PageUtils;
import com.ruoyi.common.core.page.PagePlus;
import com.ruoyi.common.core.page.TableDataInfo;
import org.springframework.stereotype.Service;
import com.ruoyi.common.core.mybatisplus.core.ServicePlusImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.ruoyi.zhdd.domain.bo.DutyEmpBo;
import com.ruoyi.zhdd.domain.vo.DutyEmpVo;
import com.ruoyi.zhdd.domain.DutyEmp;
import com.ruoyi.zhdd.mapper.DutyEmpMapper;
import com.ruoyi.zhdd.service.IDutyEmpService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 值班排班信息Service业务层处理
 *
 * @author xintong
 * @date 2021-10-11
 */
@Service
public class DutyEmpServiceImpl extends ServicePlusImpl<DutyEmpMapper, DutyEmp, DutyEmpVo> implements IDutyEmpService {

    @Override
    public DutyEmpVo queryById(String id){
        return getVoById(id);
    }

    @Override
    public TableDataInfo<DutyEmpVo> queryPageList(DutyEmpBo bo) {
        PagePlus<DutyEmp, DutyEmpVo> result = pageVo(PageUtils.buildPagePlus(), buildQueryWrapper(bo));
        return PageUtils.buildDataInfo(result);
    }

    @Override
    public List<DutyEmpVo> queryList(DutyEmpBo bo) {
        return listVo(buildQueryWrapper(bo));
    }

    private LambdaQueryWrapper<DutyEmp> buildQueryWrapper(DutyEmpBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<DutyEmp> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getPeriod() != null, DutyEmp::getPeriod, bo.getPeriod());
        lqw.like(StringUtils.isNotBlank(bo.getEmpName()), DutyEmp::getEmpName, bo.getEmpName());
        return lqw;
    }

    @Override
    public Boolean insertByBo(DutyEmpBo bo) {
        DutyEmp add = BeanUtil.toBean(bo, DutyEmp.class);
        validEntityBeforeSave(add);
        return save(add);
    }

    @Override
    public Boolean updateByBo(DutyEmpBo bo) {
        DutyEmp update = BeanUtil.toBean(bo, DutyEmp.class);
        validEntityBeforeSave(update);
        return updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(DutyEmp entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<String> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return removeByIds(ids);
    }
}
